#include <windows.h>
#include <ShlObj.h>
#include <stdlib.h>
#include <string.h>
#include "APWPOST.H"

HGLOBAL WINAPI BrowseForFolder (AWPARAM_PTR awParam, LPCTSTR instructions, LPCTSTR rootPath) {
	HGLOBAL path = GlobalAlloc( GHND, sizeof(char) * MAX_PATH );
	
	if (path) {
		wchar_t pwszRootPath[MAX_PATH];
		LPITEMIDLIST pidlRoot = NULL;
		BROWSEINFO bi;
		LPITEMIDLIST pidlFolder = NULL;
		
		mbstowcs(pwszRootPath, rootPath, strlen(rootPath) + 1);
		//ILCreateFromPathW
		//Minimum DLL Version:       shell32.dll version 5.0 or later 
		//Minimum Operating System:  Windows 2000 
		pidlRoot = ILCreateFromPathW(pwszRootPath);

		bi.hwndOwner = awParam->hwnd;
		bi.lpszTitle = instructions;
		bi.pidlRoot = pidlRoot;
		bi.ulFlags = BIF_NEWDIALOGSTYLE;
		bi.lpfn = NULL;
		bi.lParam = 0;
		bi.pszDisplayName = (LPTSTR) malloc( sizeof(TCHAR) * MAX_PATH );
		
		if (bi.pszDisplayName) {
			//SHBrowseForFolder
			//Minimum DLL Version:       shell32.dll version 4.0 or later 
			//Minimum Operating System:  Windows NT 4.0, Windows 95
			pidlFolder = SHBrowseForFolder(&bi);
			
			free(bi.pszDisplayName);
			bi.pszDisplayName = NULL;
		}
		
		//SHGetPathFromIDList
		//Minimum DLL Version:       shell32.dll version 4.0 or later 
		//Minimum Operating System:  Windows NT 4.0, Windows 95
		SHGetPathFromIDList( pidlFolder, (LPSTR) GlobalLock(path) );
		GlobalUnlock(path);
		

		//ILFree
		//Minimum DLL Version:       shell32.dll version 5.0 or later 
		//Minimum Operating System:  Windows 2000 
		if (pidlFolder)
			ILFree(pidlFolder);
		
		if (pidlRoot)
			ILFree(pidlRoot);
	}
	return path;
}
